drm/i915: Sync drm_irq.c with Linux 3.8.13
[dragonfly.git] / UPDATING
1 # Updating Information for DragonFly users.
2 #
3 #
4 # This file should warn you of any pitfalls which you might need to work around
5 # when trying to update your DragonFly system.  The information below is
6 # in reverse-time order, with the latest information at the top.
7 #
8 # If you discover any problem, please contact the bugs@lists.dragonflybsd.org
9 # mailing list with the details.
10
11 +-----------------------------------------------------------------------+
12 +         UPGRADING DRAGONFLY FROM 3.8 TO LATER VERSIONS                +
13 +-----------------------------------------------------------------------+
14
15 OLDER NETWORK DRIVERS MOVED TO I386 ONLY
16 ----------------------------------------
17
18 The following drivers have been made i386 only: ed(4), sr(4), ng_sync_ar
19 and ng_sync_sr. ed(4) used to be in X86_64_GENERIC, so it has to be
20 removed in kernel configs derived from X86_64_GENERIC.
21
22 +-----------------------------------------------------------------------+
23 +         UPGRADING DRAGONFLY FROM 3.6 TO LATER VERSIONS                +
24 +-----------------------------------------------------------------------+
25
26 ATM, IPX, NCP AND NWFS SUPPORT DROPPED
27 --------------------------------------
28
29 Support for the IPX and NCP network protocols and for mouting NetWare
30 file systems has been dropped. Dito for ATM protocol support.
31
32 INITRD IMAGES NOW INSTALLED BY DEFAULT
33 --------------------------------------
34
35 An initial ramdisk image is now installed in /boot/kernel/initrd.img.gz
36
37 Older images installed under the file name of initrd.img will be removed
38 automatically by the make upgrade process.
39
40 USB4BSD IS NOW THE DEFAULT USB STACK
41 ------------------------------------
42
43 To get back to the old stack, put "WANT_OLDUSB=yes" in /etc/make.conf and
44 replace "device usb" with "device oldusb" in the kernel configuration.
45
46 MORE ISA SUPPORT DROPPED
47 ------------------------
48
49 ISA support has been dropped from the following drivers: adv(4), an(4),
50 ar(4), cs(4), digi(4), ed(4), ep(4), ex(4), fe(4), lnc(4), sbni(4),
51 si(4), sn(4), and stg(4).
52
53 +-----------------------------------------------------------------------+
54 +         UPGRADING DRAGONFLY FROM 3.4 TO LATER VERSIONS                +
55 +-----------------------------------------------------------------------+
56
57 ABI CHANGE
58 ----------
59
60 Installed third-party software (dports) will have to be rebuilt after upgrade,
61 or reinstalled from binary packages.
62
63 UPDATING FROM 3.4 TO 3.6
64 ------------------------
65
66 This only applies for this specific upgrade due to locale changes; it is 
67 not needed for upgrades after 3.6.  Please update in this order:
68
69 make buildworld
70 make buildkernel
71 make installworld
72 make installkernel
73 *reboot*
74 make upgrade
75
76 See this mailing list post for details:
77 http://lists.dragonflybsd.org/pipermail/users/2013-September/090163.html
78
79 CYRIX OPTIONS REMOVED
80 ---------------------
81
82 The following Cyrix related options have been removed: CPU_BTB_EN,
83 CPU_CYRIX_NO_LOCK, CPU_DIRECT_MAPPED_CACHE, CPU_DISABLE_5X86_LSSER,
84 CPU_FASTER_5X86_FPU, CPU_IORT, CPU_LOOP_EN, CPU_RSTK_EN, CPU_SUSP_HLT,
85 CYRIX_CACHE_WORKS, and CYRIX_CACHE_REALLY_WORKS
86
87 ISA SUPPORT REMOVED FROM RP(4)
88 ------------------------------
89
90 ISA support has been removed from the rp(4) driver. It is now PCI only.
91
92 +-----------------------------------------------------------------------+
93 +         UPGRADING DRAGONFLY FROM 3.2 TO LATER VERSIONS                +
94 +-----------------------------------------------------------------------+
95
96 COMPAT_SUNOS OPTION REMOVED
97 ---------------------------
98
99 The COMPAT_SUNOS option has been removed. It was meant to provide binary
100 compatibility with SunOS 4.x for the sparc32 port of 4.4BSD.
101
102 ISA SOUND CARD SUPPORT REMOVED
103 ------------------------------
104
105 The following modules have been removed (all for ISA sound cards):
106 snd_ad1816.ko, snd_ess.ko, snd_mss.ko, snd_sb8.ko, snd_sb16.ko, snd_sbc.ko
107
108 GCC 4.7
109 -------
110
111 DragonFly has switched base compilers.  GCC 4.7 is now the default
112 compiler and GCC 4.4 is the alternative compiler.  The "NO_GCC47" make
113 variable ceases to work now.
114
115 Users who wish to build only GCC 4.7 have to use NO_GCC44 in the
116 /etc/make.conf to prohibit GCC 4.4 from building.  However, using it is
117 highly discouraged.  There are a few packages in pkgsrc that do not build
118 with GCC 4.7 and the new "DPorts" system uses GCC 4.4 by default.  At
119 this time, it is recommended to keep both compilers on the base system.
120
121 SMP OPTION REMOVED
122 ------------------
123
124 The SMP kernel option has been made a no-op. All kernels now feature SMP
125 support. If you have 'options SMP' in your kernel config, you can as well
126 remove it.
127
128 DEVICE_POLLING OPTION REPLACED BY IFPOLL_ENABLE OPTION, KTR_POLLING REMOVED
129 ---------------------------------------------------------------------------
130
131 The DEVICE_POLLING kernel option has been made a no-op and it has been
132 replaced by IFPOLL_ENABLE.  If you have 'options DEVICE_POLLING' in your
133 kernel config, you need to change it to IFPOLL_ENABLE.
134
135 Also, the KTR_POLLING kernel option has been removed, so it must be
136 removed from kernel configs that have it.
137
138 BUSLOGIC, CYCLADES AND STALLION ISA SUPPORT REMOVED
139 ---------------------------------------------------
140
141 The bt(4) driver for Buslogic SCSI adapters has been made PCI only. ISA
142 cards will no longer be detected.
143
144 The same has been done for Stallion multiport serial controllers. stli(4)
145 has been completely removed (along with the stlload(8) and stlstty(8)
146 utilities) and stl(4) was changed to support only PCI cards. Similarly,
147 ISA support was removed from cy(4) too. All these drivers are i386 only.
148
149 COMPAT_OLDISA OPTION GONE
150 -------------------------
151
152 The i386 specific COMPAT_OLDISA kernel option has been removed, since
153 nothing needs it anymore.
154
155 +-----------------------------------------------------------------------+
156 +         UPGRADING DRAGONFLY FROM 3.0 TO LATER VERSIONS                +
157 +-----------------------------------------------------------------------+
158
159 APIC_IO OPTION REMOVED
160 ----------------------
161
162 The APIC_IO kernel option is no longer accepted after having been without
163 effect for a while. The hw.ioapic_enable tunable now serves its purpose.
164 If you have 'options APIC_IO' in your kernel config, you'll have to
165 remove it.
166
167 WATCHDOG_ENABLE & HW_WDOG OPTIONS REMOVED
168 -----------------------------------------
169
170 The wdog framework is now compiled into our kernels by default, so the
171 options are no longer needed.
172
173 DOSCMD(1) REMOVED
174 -----------------
175
176 doscmd(1) has been removed. It was i386 only. The doscmd(1) specific
177 NO_X make.conf option was removed too.
178
179 GCC 4.7
180 -------
181
182 GCC 4.7 has been brought in and replaces GCC 4.1 as DragonFly's non-
183 default compiler in base (default is still GCC 4.4).
184
185 Users who wish to build only GCC 4.4 have to replace NO_GCC41 with
186 NO_GCC47 in /etc/make.conf.
187
188 USB4BSD
189 -------
190
191 A new USB stack (from FreeBSD) has been brought in. The following
192 modules have been ported so far: usb, uhci, ohci, ehci, xhci, umass,
193 usfs, uether, if_axe, if_udav, ukbd, ums, uep, uhid, usb_quirk,
194 and uaudio.
195
196 It is not yet the default. To activate it, WANT_USB4BSD=yes has to
197 be put in make.conf and device "usb4bsd" (quotes needed) has to
198 replace device usb in the kernel config. After that, a full
199 build/install/upgrade cycle is needed.
200
201 Note that this is experimental and incomplete, but we are interested
202 in hearing about issues with it, of course.
203
204 ISA SUPPORT REMOVED FROM AIC-6260/6360 DRIVER
205 ---------------------------------------------
206
207 ISA adapter support was dropped from the aic(4) driver.
208
209 +-----------------------------------------------------------------------+
210 +         UPGRADING DRAGONFLY FROM 2.10 TO LATER VERSIONS               +
211 +-----------------------------------------------------------------------+
212
213 SEVERAL ISA DRIVERS REMOVED
214 ---------------------------
215
216 The following ISA only drivers have been removed along with a couple of
217 associated userland tools:
218
219 aha(4)
220 asc(4) & sasc(1)
221 ctx
222 dgb(4)
223 el(4)
224 gpib
225 gsc(4) & sgsc(1)
226 ie(4)
227 labpc(4)
228 le(4)
229 mse(4)
230 rc(4)
231 rdp(4)
232 spigot
233 tw(4) & xten(1) & xtend(8)
234 wl(4) & wlconfig(8)
235 wt(4)
236
237 Note that two of these drivers (aha(4) and ie(4)) are in our GENERIC
238 config and one (aha(4)) is in our X86_64_GENERIC kernel configuration
239 file.
240
241 If buildkernel complains about any of these drivers, just remove them
242 from your kernel configuration.
243
244 BINUTILS 2.20
245 -------------
246 Binutils 2.20 has been removed in favor of Binutils 2.22.  The accepted
247 values of BINUTILSVERS are now binutils221 and binutils222 (default).
248
249 BUILDWORLD/-KERNEL PARALLELIZATION WORK
250 ---------------------------------------
251 Due to changes in the way we build with more than one make job, you
252 will have to update install(1) and mkdir(1) prior to buildworld if you
253 want to build with 'make -j':
254
255 cd /usr/src/usr.bin/xinstall; make; make install; make clean
256 cd /usr/src/bin/mkdir; make; make install; make clean
257
258 DMA(8) UPGRADE
259 --------------
260 dma(8) has been upgraded to v0.7 which no longer supports the
261 /etc/dma/virtusertable. Some of its functionality has been replaced
262 with the MASQUERADE keyword and the EMAIL environment variable (see
263 the dma(8) manual page).
264
265 +-----------------------------------------------------------------------+
266 +         UPGRADING DRAGONFLY FROM 2.8 TO LATER VERSIONS                +
267 +-----------------------------------------------------------------------+
268
269 GCC 4.4 & BINUTILS 2.21
270 -----------------------
271
272 GCC 4.4 has been made DragonFly's default compiler and Binutils 2.21 has
273 been made DragonFly's default Binutils.
274
275 That means that any settings that set CCVER to 'gcc44' are not needed
276 anymore. Instead, CCVER can be set to 'gcc41' to go back to using
277 GCC 4.1.
278
279 It also means that 'binutils221' as a value for BINUTILSVER has no
280 effect anymore. 2.17 has been removed and 'binutils220' is available
281 as an option.
282
283 The NO_GCC44 option has been removed and will not affect the build
284 anymore. There is now a NO_GCC41 option that will prevent GCC 4.1 from
285 building in a similar fashion.
286
287 Note that you must do a full buildworld/buildkernel for upgrading.
288
289 pkg_radd settings
290 -----------------
291
292 The config file for pkg_radd has moved from /etc/settings.conf to 
293 /etc/pkg_radd.conf.  Save the contents of settings.conf before upgrading
294 if this is needed.  This warning only applies if /etc/settings.conf 
295 exists.  pkg_radd will continue to work with defaults.
296
297 +-----------------------------------------------------------------------+
298 +         20100927                                                      +
299 +         UPGRADING DRAGONFLY FROM 2.6 to 2.8 or HEAD                   +
300 +-----------------------------------------------------------------------+
301
302 OpenSSL
303 --------
304
305 OpenSSL has been upgraded, and SHLIB_MAJOR was bumped for libssh and libcrypto.
306 This shouldn't break any 3rd-party software, but you'll need to recompile your
307 3rd-party software if you want it to link against the new version of OpenSSL.
308
309 Loader
310 -------
311
312 A new loader (dloader) has been added which better handles booting from
313 multiple kernel/module versions.
314
315 To upgrade (Only for this upgrade, for post 2.8 upgrades see GENERAL below)
316
317         cd /usr/src
318         make buildworld
319         make installworld
320         make upgrade
321         make buildkernel KERNCONF=<KERNELNAME>
322         make installkernel KERNCONF=<KERNELNAME>
323
324 Note that you must installworld and run the 'upgrade' target before
325 installing the new kernel.
326
327 BIND
328 -----
329
330 BIND has been removed from the base system.  The ldns and drill tools have 
331 been added for basic functionality.  Use 'drill' where you would normally 
332 use nslookup or dig, or install BIND from pkgsrc.  It's available as 
333 net/bind95, net/bind96, or net/bind97 as of this writing.
334
335 This only affects older systems upgrading to 2.8.  New 2.8+ installs 
336 include BIND as a pkgsrc package.
337
338 +-----------------------------------------------------------------------+
339 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
340 +                               GENERAL                                 +
341 +-----------------------------------------------------------------------+
342
343 Instructions on how to obtain and maintain DragonFly source code using git
344 are in the development(7) manual page.
345
346 To upgrade a DragonFly system from sources you run the following sequence:
347
348         cd /usr/src
349         make buildworld
350         make buildkernel KERNCONF=<KERNELNAME>
351         make installkernel KERNCONF=<KERNELNAME>
352         make installworld
353
354 You will also want to run the 'upgrade' target to upgrade your /etc and the
355 rest of your system.  The upgrade target is aware of stale files created by
356 older DragonFly installations and should delete them automatically.
357
358         make upgrade
359
360 See the build(7) manual page for further information.
361
362 Once you've done a full build of the world and kernel you can do incremental
363 upgrades of either by using the 'quickworld' and 'quickkernel' targets
364 instead of 'buildworld' and 'buildkernel'.  If you have any problems with
365 the quick targets, try updating your repo first, and then a full buildworld
366 and buildkernel as shown above, before asking for help.
367
368 +-----------------------------------------------------------------------+
369 +         UPGRADING FROM DRAGONFLY <= 2.0 TO DRAGONFLY >= 2.1           +
370 +-----------------------------------------------------------------------+
371
372 In 2.1 kernel and modules has moved to boot directory.  For most cases
373 this is handled automatically by 'make upgrade'.  A few cases needs manual
374 intervention:
375
376  * When installing a kernel without first doing a make buildworld,
377    installworld and upgrade to the same DESTDIR as kernel:
378    make DESTDIR/boot directory and move kernel and modules into this boot
379    directory; also move kernel.old and modules.old.
380    Typical example is vkernel(7), use (no modules used):
381
382         cd /var/vkernel
383         mkdir boot
384         chflags noschg kernel
385         mv kernel kernel.old boot
386         chflags schg boot/kernel
387         
388  * When using a boot-only partition, /boot/loader.rc needs to be edited:
389    delete occurrences of '/boot/'.
390    These occurences can normally be deleted in any case, see loader(8).
391
392 +-----------------------------------------------------------------------+
393 +         UPGRADING FROM DRAGONFLY <= 1.8 TO DRAGONFLY >= 1.9           +
394 +-----------------------------------------------------------------------+
395
396 In 1.9 major changes to the disk management infrastructure have taken
397 place.  make upgrade may not catch all of your disk devices in /dev,
398 so after upgrading be sure to cd /dev; ./MAKEDEV <blah> where <blah>
399 are all of your disk devices.  HOWEVER, from late 2.3 on we run devfs
400 and MAKEDEV no longer exists.
401
402 The biggest changes in 1.9 are:
403
404 (1) That whole-slice devices such as da0s1 no longer share the same device
405     id as partition c devices such as da0s1c.
406
407 (2) The whole-disk device (e.g. da0) is full raw access to the disk,
408     with no snooping or reserved sectors.  Consequently you cannot run
409     disklabel on this device.  Instead you must run disklabel on a
410     whole-slice device.
411
412 (3) The 'compatibility' partitions now use slice 0 in the device name,
413     so instead of da0a you must specify da0s0a.  Also, as per (1) above,
414     accessing the disklabel for the compatibility partitions must be
415     done via slice 0 (da0s0).
416
417 (4) Many device drivers that used to fake up labels, such as CD, ACD, VN,
418     and CCD now run through the disk management layer and are assigned
419     real disk management devices.   VN and CCD in particular do not usually
420     use a MBR and disklabels must be accessed through the compatibility
421     slice 0.  Your /etc/ccd.conf file still specifies 'ccd0', though, you
422     don't name it 'ccd0s0' in the config file.
423
424 Generally speaking, you have to get used to running fdisk and disklabel on
425 the correctly specified device names.  A lot of the wiggle, such as running
426 disklabel on a partition, has been removed.
427
428 +-----------------------------------------------------------------------+
429 +         UPGRADING FROM OLDER VERSIONS OF DRAGONFLY OR FREEBSD         +
430 +-----------------------------------------------------------------------+
431
432 > Kerberos IV
433 -------------
434
435 Kerberos IV (eBones) was removed from the tree, please consider moving to
436 Kerberos 5 (Heimdal).
437
438 > Package Management System
439 ---------------------------
440
441 Starting with the 1.4 release, DragonFly uses NetBSD's pkgsrc package
442 management system.  The necessary tools to build and maintain packages
443 are provided in /usr/pkg/bin and /usr/pkg/sbin.  Make sure that these
444 directories are in your PATH variable.
445
446 In order to obtain a reasonably current snapshot of the pkgsrc tree, use
447 the tarball from NetBSD:
448
449         fetch -o /tmp/pkgsrc.tar.gz ftp://ftp.NetBSD.org/pub/NetBSD/packages/pkgsrc.tar.gz
450         cd /usr; tar -xzf /tmp/pkgsrc.tar.gz; chown -R root:wheel pkgsrc
451
452 This tree can then be kept up to date with cvs update:
453
454         cd /usr/pkgsrc; cvs up
455
456 NOTE! If you upgraded from a pre-1.4 system to 1.4 or later, you need to
457 build and install the pkgsrc bootstrap manually:
458
459         cd /usr/pkgsrc/bootstrap
460         ./bootstrap --pkgdbdir /var/db/pkg --prefix /usr/pkg
461
462 +-----------------------------------------------------------------------+
463 +         UPGRADING DRAGONFLY ON AN EXISTING DRAGONFLY SYSTEM           +
464 +         UPDATING FROM PRE-1.2 SYSTEMS OR FreeBSD 4.x TO               +
465 +         DRAGONFLY 1.3+ (EITHER PREVIEW or HEAD)                       +
466 +-----------------------------------------------------------------------+
467
468 The compatibility shims for the build environment have been removed, you
469 have to update to DragonFly 1.2 release branch first.
470
471 The default PAM configuration has moved from /etc/pam.conf to /etc/pam.d/.
472 The existing configuration can be converted using /etc/pam.d/convert.sh.
473 Entries in /etc/pam.d/ override entries in /etc/pam.conf. In addition
474 the pam_skey.so module was retired, you have to remove it manually from
475 your configuration, when you convert it.
476
477 > Required user and group IDs when upgrading from either FreeBSD or DragonFly
478 ---------------------
479
480 The following users may be missing from your password file.  Use vipw and
481 add any that are missing:
482
483 smmsp:*:25:25::0:0:Sendmail Submission User:/var/spool/clientmqueue:/sbin/nologin
484 _pflogd:*:64:64::0:0:pflogd privsep user:/var/empty:/sbin/nologin
485
486 The following groups may be missing from your group file.  Use vi /etc/group
487 and add any that are missing:
488
489 smmsp:*:25:
490 authpf:*:63:
491 _pflogd:*:64:
492
493
494 > Upgrading to DragonFly from FreeBSD
495 ---------------------
496
497 You can build the DragonFly world and DragonFly kernels on a FreeBSD-4.x or
498 FreeBSD-5.x machine and then install DragonFly over FreeBSD, replacing
499 FreeBSD.  Note that the DragonFly buildworld target does not try to reuse
500 make depend information, it starts from scratch, so no pre-cleaning of the
501 object hierarchy is necessary.
502
503         # get the CVS repository (it is placed in /home/dcvs, 500MB).
504         # Please use the -h option and a mirror site to pull the 
505         # initial repository, but feel free to use the main repository
506         # machine to pull updates.
507         cvsup /usr/share/examples/cvsup/DragonFly-cvs-supfile
508         # install the source from the CVS hierarchy (remove preexisting
509         # FreeBSD src first) (500MB)
510         cd /usr
511         rm -rf src
512         cvs -R -d /home/dcvs checkout -P src
513
514         # build it (500MB used in /usr/obj)
515         #
516         cd /usr/src
517         make buildworld
518         make buildkernel KERNCONF=<KERNELNAME>
519
520 Once you have built DragonFly you have to install it over FreeBSD.  Since
521 DragonFly does not track changes made by FreeBSD to its include file 
522 hierarchy and include file pollution can cause all sorts of unexpected
523 compilation issues to come up, it is best to wipe your include hierarchy
524 prior to installing DragonFly.  Note that you should not wipe any installed
525 FreeBSD header files or binaries until after you have successfully completed
526 the build steps above.
527
528         rm -rf /usr/include
529         mkdir /usr/include
530         make installkernel KERNCONF=<KERNELNAME>
531         make installworld
532
533 Then you need to upgrade your system.  DragonFly's 'make upgrade' target 
534 will unconditionally upgrade the /etc files that sysops do not usually
535 mess around with, such as the files in /etc/rc.d.  It will also remove any
536 obsolete files such as utilities and manpages that have been removed from
537 the system since the version you're coming from.  If you are unsure we 
538 recommend that you make a backup of at least your /etc before applying
539 this step.  Note that DragonFly's RC system is basically RCNG from
540 FreeBSD-5, but there are some differences in the contents of the RC files.
541
542         make upgrade
543
544 NOTE! Never do a 'make upgrade' before 'make installworld' has been run.
545 Doing so might leave your system in an unusable state.
546
547 Finally we recommend that you do an 'ls -lta BLAH' for /bin, /sbin, /usr/bin,
548 /usr/bin, and /usr/lib, and remove any stale files that you find.  Please
549 report these files to the DragonFly developers so that they can be added to
550 the 'upgrade' target.
551